diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java b/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
index fc928805f..ced3b0458 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
@@ -10,23 +10,26 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.data.gamerule.GameRule;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.item.Items;
+import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypes;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.ArrayList;
 import java.util.Collection;
 import java.util.List;
 
-public class Registries extends Registry<Registry<?>>
-{
-    public static final Registry<WorldType> WORLD_TYPES = new Registry<>();
-    public static final Registry<Biome> BIOMES = new Registry<>();
-    public static final Registry<GameRule<?>> GAME_RULES = new Registry<>();
-    public static final Registry<Class<? extends RecipeEntryBase<?,?,?>>> RECIPE_TYPES = new Registry<>();
-    public static final Registry<List<ItemStack>> ITEM_GROUPS = new Registry<>();
+public class Registries extends Registry<Registry<?>> {
+    public static final @NotNull Registry<@NotNull WorldType> WORLD_TYPES = new Registry<>();
+    public static final @NotNull Registry<@NotNull Biome> BIOMES = new Registry<>();
+    public static final @NotNull Registry<@NotNull GameRule<?>> GAME_RULES = new Registry<>();
+    public static final @NotNull Registry<@NotNull Gamemode> GAMEMODES = new Registry<>();
+    public static final @NotNull Registry<@NotNull Class<? extends RecipeEntryBase<?, ?, ?>>> RECIPE_TYPES = new Registry<>();
+    public static final @NotNull Registry<@NotNull List<@NotNull ItemStack>> ITEM_GROUPS = new Registry<>();
     public static RecipeRegistry RECIPES;
     public static RecipeRegistry RECIPES_LOCAL_COPY;
 
@@ -35,22 +38,26 @@ public class Registries extends Registry<Registry<?>>
 
     public static boolean init = false;
 
-    public Registries(){
-        if(init) return;
+    public Registries() {
+        if (init) return;
         init = true;
         INSTANCE = this;
-        register("minecraft:world_types",WORLD_TYPES);
-        register("minecraft:biomes",BIOMES);
-        register("minecraft:recipe_types",RECIPE_TYPES);
-        register("minecraft:item_groups",ITEM_GROUPS);
-        init();
-        register("minecraft:recipes",RECIPES);
+
+        this.init();
+        this.register("minecraft:world_types", WORLD_TYPES);
+        this.register("minecraft:biomes", BIOMES);
+        this.register("minecraft:gamerules", GAME_RULES);
+        this.register("minecraft:gamemodes", GAMEMODES);
+        this.register("minecraft:recipe_types", RECIPE_TYPES);
+        this.register("minecraft:item_groups", ITEM_GROUPS);
+        this.register("minecraft:recipes", RECIPES);
     }
 
-    private void init(){
+    private void init() {
         WorldTypes.init();
         Biomes.init();
         GameRules.init();
+        Gamemodes.init();
 
         RECIPE_TYPES.register("minecraft:crafting/shaped", RecipeEntryCraftingShaped.class);
         RECIPE_TYPES.register("minecraft:crafting/shapeless", RecipeEntryCraftingShapeless.class);
@@ -67,38 +74,38 @@ public class Registries extends Registry<Registry<?>>
         RECIPE_TYPES.register("minecraft:smelting/blast", RecipeEntryBlastFurnace.class);
         RECIPE_TYPES.register("minecraft:trommeling", RecipeEntryTrommel.class);
 
-        ITEM_GROUPS.register("minecraft:stones",stackListOf(Blocks.STONE, Blocks.BASALT, Blocks.LIMESTONE, Blocks.GRANITE, Blocks.PERMAFROST, Blocks.NETHERRACK));
-        ITEM_GROUPS.register("minecraft:cobblestones",stackListOf(Blocks.COBBLE_STONE, Blocks.COBBLE_BASALT, Blocks.COBBLE_LIMESTONE, Blocks.COBBLE_GRANITE, Blocks.COBBLE_PERMAFROST, Blocks.COBBLE_NETHERRACK));
-        ITEM_GROUPS.register("minecraft:grasses",stackListOf(Blocks.GRASS, Blocks.GRASS_RETRO));
-        ITEM_GROUPS.register("minecraft:dirt",stackListOf(Blocks.DIRT, Blocks.DIRT_SCORCHED));
-        ITEM_GROUPS.register("minecraft:trommel_dirt",stackListOf(Blocks.DIRT, Blocks.DIRT_SCORCHED, Blocks.GRASS, Blocks.GRASS_RETRO, Blocks.GRASS_SCORCHED, Blocks.PATH_DIRT, Blocks.FARMLAND_DIRT));
-        ITEM_GROUPS.register("minecraft:moss_stones",stackListOf(Blocks.MOSS_STONE, Blocks.MOSS_BASALT, Blocks.MOSS_LIMESTONE, Blocks.MOSS_GRANITE));
-        ITEM_GROUPS.register("minecraft:logs",stackListOf(Blocks.LOG_OAK, Blocks.LOG_PINE, Blocks.LOG_BIRCH, Blocks.LOG_CHERRY, Blocks.LOG_EUCALYPTUS, Blocks.LOG_OAK_MOSSY, Blocks.LOG_THORN, Blocks.LOG_PALM));
-        ITEM_GROUPS.register("minecraft:leaves",stackListOf(Blocks.LEAVES_OAK, Blocks.LEAVES_OAK_RETRO, Blocks.LEAVES_PINE, Blocks.LEAVES_BIRCH, Blocks.LEAVES_CHERRY, Blocks.LEAVES_EUCALYPTUS, Blocks.LEAVES_SHRUB));
-        ITEM_GROUPS.register("minecraft:coal_ores",stackListOf(Blocks.ORE_COAL_STONE, Blocks.ORE_COAL_BASALT, Blocks.ORE_COAL_LIMESTONE, Blocks.ORE_COAL_GRANITE, Blocks.ORE_COAL_PERMAFROST));
-        ITEM_GROUPS.register("minecraft:iron_ores",stackListOf(Blocks.ORE_IRON_STONE, Blocks.ORE_IRON_BASALT, Blocks.ORE_IRON_LIMESTONE, Blocks.ORE_IRON_GRANITE, Blocks.ORE_IRON_PERMAFROST));
-        ITEM_GROUPS.register("minecraft:gold_ores",stackListOf(Blocks.ORE_GOLD_STONE, Blocks.ORE_GOLD_BASALT, Blocks.ORE_GOLD_LIMESTONE, Blocks.ORE_GOLD_GRANITE, Blocks.ORE_GOLD_PERMAFROST));
-        ITEM_GROUPS.register("minecraft:lapis_ores",stackListOf(Blocks.ORE_LAPIS_STONE, Blocks.ORE_LAPIS_BASALT, Blocks.ORE_LAPIS_LIMESTONE, Blocks.ORE_LAPIS_GRANITE, Blocks.ORE_LAPIS_PERMAFROST));
-        ITEM_GROUPS.register("minecraft:redstone_ores",stackListOf(Blocks.ORE_REDSTONE_STONE, Blocks.ORE_REDSTONE_BASALT, Blocks.ORE_REDSTONE_LIMESTONE, Blocks.ORE_REDSTONE_GRANITE, Blocks.ORE_REDSTONE_PERMAFROST, Blocks.ORE_REDSTONE_GLOWING_STONE, Blocks.ORE_REDSTONE_GLOWING_BASALT, Blocks.ORE_REDSTONE_GLOWING_LIMESTONE, Blocks.ORE_REDSTONE_GLOWING_GRANITE, Blocks.ORE_REDSTONE_GLOWING_PERMAFROST));
-        ITEM_GROUPS.register("minecraft:diamond_ores",stackListOf(Blocks.ORE_DIAMOND_STONE, Blocks.ORE_DIAMOND_BASALT, Blocks.ORE_DIAMOND_LIMESTONE, Blocks.ORE_DIAMOND_GRANITE, Blocks.ORE_DIAMOND_PERMAFROST));
+        ITEM_GROUPS.register("minecraft:stones", stackListOf(Blocks.STONE, Blocks.BASALT, Blocks.LIMESTONE, Blocks.GRANITE, Blocks.PERMAFROST, Blocks.NETHERRACK));
+        ITEM_GROUPS.register("minecraft:cobblestones", stackListOf(Blocks.COBBLE_STONE, Blocks.COBBLE_BASALT, Blocks.COBBLE_LIMESTONE, Blocks.COBBLE_GRANITE, Blocks.COBBLE_PERMAFROST, Blocks.COBBLE_NETHERRACK));
+        ITEM_GROUPS.register("minecraft:grasses", stackListOf(Blocks.GRASS, Blocks.GRASS_RETRO));
+        ITEM_GROUPS.register("minecraft:dirt", stackListOf(Blocks.DIRT, Blocks.DIRT_SCORCHED));
+        ITEM_GROUPS.register("minecraft:trommel_dirt", stackListOf(Blocks.DIRT, Blocks.DIRT_SCORCHED, Blocks.GRASS, Blocks.GRASS_RETRO, Blocks.GRASS_SCORCHED, Blocks.PATH_DIRT, Blocks.FARMLAND_DIRT));
+        ITEM_GROUPS.register("minecraft:moss_stones", stackListOf(Blocks.MOSS_STONE, Blocks.MOSS_BASALT, Blocks.MOSS_LIMESTONE, Blocks.MOSS_GRANITE));
+        ITEM_GROUPS.register("minecraft:logs", stackListOf(Blocks.LOG_OAK, Blocks.LOG_PINE, Blocks.LOG_BIRCH, Blocks.LOG_CHERRY, Blocks.LOG_EUCALYPTUS, Blocks.LOG_OAK_MOSSY, Blocks.LOG_THORN, Blocks.LOG_PALM));
+        ITEM_GROUPS.register("minecraft:leaves", stackListOf(Blocks.LEAVES_OAK, Blocks.LEAVES_OAK_RETRO, Blocks.LEAVES_PINE, Blocks.LEAVES_BIRCH, Blocks.LEAVES_CHERRY, Blocks.LEAVES_EUCALYPTUS, Blocks.LEAVES_SHRUB));
+        ITEM_GROUPS.register("minecraft:coal_ores", stackListOf(Blocks.ORE_COAL_STONE, Blocks.ORE_COAL_BASALT, Blocks.ORE_COAL_LIMESTONE, Blocks.ORE_COAL_GRANITE, Blocks.ORE_COAL_PERMAFROST));
+        ITEM_GROUPS.register("minecraft:iron_ores", stackListOf(Blocks.ORE_IRON_STONE, Blocks.ORE_IRON_BASALT, Blocks.ORE_IRON_LIMESTONE, Blocks.ORE_IRON_GRANITE, Blocks.ORE_IRON_PERMAFROST));
+        ITEM_GROUPS.register("minecraft:gold_ores", stackListOf(Blocks.ORE_GOLD_STONE, Blocks.ORE_GOLD_BASALT, Blocks.ORE_GOLD_LIMESTONE, Blocks.ORE_GOLD_GRANITE, Blocks.ORE_GOLD_PERMAFROST));
+        ITEM_GROUPS.register("minecraft:lapis_ores", stackListOf(Blocks.ORE_LAPIS_STONE, Blocks.ORE_LAPIS_BASALT, Blocks.ORE_LAPIS_LIMESTONE, Blocks.ORE_LAPIS_GRANITE, Blocks.ORE_LAPIS_PERMAFROST));
+        ITEM_GROUPS.register("minecraft:redstone_ores", stackListOf(Blocks.ORE_REDSTONE_STONE, Blocks.ORE_REDSTONE_BASALT, Blocks.ORE_REDSTONE_LIMESTONE, Blocks.ORE_REDSTONE_GRANITE, Blocks.ORE_REDSTONE_PERMAFROST, Blocks.ORE_REDSTONE_GLOWING_STONE, Blocks.ORE_REDSTONE_GLOWING_BASALT, Blocks.ORE_REDSTONE_GLOWING_LIMESTONE, Blocks.ORE_REDSTONE_GLOWING_GRANITE, Blocks.ORE_REDSTONE_GLOWING_PERMAFROST));
+        ITEM_GROUPS.register("minecraft:diamond_ores", stackListOf(Blocks.ORE_DIAMOND_STONE, Blocks.ORE_DIAMOND_BASALT, Blocks.ORE_DIAMOND_LIMESTONE, Blocks.ORE_DIAMOND_GRANITE, Blocks.ORE_DIAMOND_PERMAFROST));
         ITEM_GROUPS.register("minecraft:nethercoal_ores", stackListOf(Blocks.ORE_NETHERCOAL_NETHERRACK));
         {
-            List<ItemStack> plankStackList = new ArrayList<>();
-            List<ItemStack> signStackList = new ArrayList<>();
-            List<ItemStack> doorStackList = new ArrayList<>();
-            List<ItemStack> chestStackList = new ArrayList<>();
-            List<ItemStack> stairsStackList = new ArrayList<>();
-            List<ItemStack> slabsStackList = new ArrayList<>();
-            List<ItemStack> fencesStackList = new ArrayList<>();
-            List<ItemStack> fenceGatesStackList = new ArrayList<>();
-            List<ItemStack> trapdoorStackList = new ArrayList<>();
-            List<ItemStack> woolStackList = new ArrayList<>();
-            List<ItemStack> lampStackList = new ArrayList<>();
-            List<ItemStack> invertedLampStackList = new ArrayList<>();
-            List<ItemStack> woodenButtonsList = new ArrayList<>();
-            List<ItemStack> woodenPressurePlatesList = new ArrayList<>();
-            List<ItemStack> buttonsList = new ArrayList<>();
-            List<ItemStack> pressurePlatesList = new ArrayList<>();
+            final List<ItemStack> plankStackList = new ArrayList<>();
+            final List<ItemStack> signStackList = new ArrayList<>();
+            final List<ItemStack> doorStackList = new ArrayList<>();
+            final List<ItemStack> chestStackList = new ArrayList<>();
+            final List<ItemStack> stairsStackList = new ArrayList<>();
+            final List<ItemStack> slabsStackList = new ArrayList<>();
+            final List<ItemStack> fencesStackList = new ArrayList<>();
+            final List<ItemStack> fenceGatesStackList = new ArrayList<>();
+            final List<ItemStack> trapdoorStackList = new ArrayList<>();
+            final List<ItemStack> woolStackList = new ArrayList<>();
+            final List<ItemStack> lampStackList = new ArrayList<>();
+            final List<ItemStack> invertedLampStackList = new ArrayList<>();
+            final List<ItemStack> woodenButtonsList = new ArrayList<>();
+            final List<ItemStack> woodenPressurePlatesList = new ArrayList<>();
+            final List<ItemStack> buttonsList = new ArrayList<>();
+            final List<ItemStack> pressurePlatesList = new ArrayList<>();
 
             plankStackList.add(Blocks.PLANKS_OAK.getDefaultStack());
             signStackList.add(Items.SIGN.getDefaultStack());
@@ -115,7 +122,7 @@ public class Registries extends Registry<Registry<?>>
             pressurePlatesList.add(Blocks.PRESSURE_PLATE_STONE.getDefaultStack());
             pressurePlatesList.add(Blocks.PRESSURE_PLATE_COBBLE_STONE.getDefaultStack());
 
-            for (DyeColor color : DyeColor.values()) {
+            for (final DyeColor color : DyeColor.values()) {
                 plankStackList.add(new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, color.blockMeta));
                 signStackList.add(new ItemStack(Items.SIGN_PAINTED, 1, color.itemMeta));
                 doorStackList.add(new ItemStack(Items.DOOR_OAK_PAINTED, 1, color.itemMeta));
@@ -135,9 +142,9 @@ public class Registries extends Registry<Registry<?>>
             buttonsList.addAll(woodenButtonsList);
             pressurePlatesList.addAll(woodenPressurePlatesList);
 
-            ITEM_GROUPS.register("minecraft:planks",plankStackList);
-            ITEM_GROUPS.register("minecraft:signs",signStackList);
-            ITEM_GROUPS.register("minecraft:doors",doorStackList);
+            ITEM_GROUPS.register("minecraft:planks", plankStackList);
+            ITEM_GROUPS.register("minecraft:signs", signStackList);
+            ITEM_GROUPS.register("minecraft:doors", doorStackList);
             ITEM_GROUPS.register("minecraft:chests", chestStackList);
             ITEM_GROUPS.register("minecraft:wools", woolStackList);
             ITEM_GROUPS.register("minecraft:lamps", lampStackList);
@@ -162,12 +169,12 @@ public class Registries extends Registry<Registry<?>>
                 new ItemStack(Items.TOOL_SWORD_DIAMOND, 1, -1),
                 new ItemStack(Items.TOOL_SWORD_STEEL, 1, -1)));
 
-        if(RECIPES == null) new RecipeRegistry();
+        if (RECIPES == null) new RecipeRegistry();
     }
 
-    public static List<ItemStack> stackListOf(Object... items) {
-        ArrayList<ItemStack> list = new ArrayList<>();
-        for (Object item : items) {
+    public static List<ItemStack> stackListOf(final Object... items) {
+        final ArrayList<ItemStack> list = new ArrayList<>();
+        for (final Object item : items) {
             if (item instanceof Block) {
                 list.add(new ItemStack((Block<?>) item));
             } else if (item instanceof Item) {
@@ -181,7 +188,7 @@ public class Registries extends Registry<Registry<?>>
         return list;
     }
 
-    public static Registries getInstance(){
+    public static Registries getInstance() {
         return INSTANCE;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/Registry.java b/game/core/src/main/java/net/minecraft/core/data/registry/Registry.java
index 0cea76c87..f4552b196 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/Registry.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/Registry.java
@@ -5,6 +5,7 @@ import com.mojang.nbt.tags.IntTag;
 import com.mojang.nbt.tags.Tag;
 import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.*;
 
@@ -78,7 +79,7 @@ public class Registry<T>
      * @param key The key of the item.
      * @return The item associated with the given key, or null if no such key-item association is present.
      */
-    public T getItem(String key)
+    public @Nullable T getItem(String key)
     {
         Objects.requireNonNull(key);
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java b/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java
index 593f35531..1e70d2221 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java
@@ -187,7 +187,7 @@ public class EntityPainting extends Entity {
     public boolean hurt(Entity entity, int i, DamageType type) {
         if (!this.removed && !this.world.isClientSide) {
             markHurt();
-            if (!(entity instanceof Player) || ((Player) entity).getGamemode().dropBlockOnBreak()) {
+            if (!(entity instanceof Player) || ((Player) entity).getGamemode().hasItemDrops()) {
                 drop();
                 remove();
             }
@@ -289,9 +289,9 @@ public class EntityPainting extends Entity {
             setStack(new ItemStack(stack.getItem(), 1, stack.getMetadata()));
             stack.consumeItem(player);
             if (stack.stackSize <= 0) {
-                player.inventory.setItem(player.inventory.getCurrentItemIndex(), null);
+                player.inventory.setItem(player.inventory.getCurrentSlot(), null);
             }
-            if (paintingStack != null && player.getGamemode().consumeBlocks()) {
+            if (paintingStack != null && player.getGamemode().hasBlockConsumption()) {
                 player.inventory.insertItem(paintingStack, true);
                 if (paintingStack.stackSize > 0) {
                     player.dropPlayerItem(paintingStack);
@@ -299,7 +299,7 @@ public class EntityPainting extends Entity {
             }
             return true;
         } else if (getBorderStack() != null) {
-            if (player.getGamemode().consumeBlocks()) {
+            if (player.getGamemode().hasBlockConsumption()) {
                 player.inventory.insertItem(getBorderStack(), true);
             }
             setStack(null);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobDeer.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobDeer.java
index 8ba37c9ed..aa14a680d 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobDeer.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobDeer.java
@@ -80,7 +80,7 @@ public class MobDeer
     protected @Nullable Entity findThreatNearby() {
         final int dist = 10;
         final Player player = this.world.getClosestPlayer(this.x, this.y, this.z, dist);
-        if (player != null && player.getGamemode().areMobsHostile()) {
+        if (player != null && player.getGamemode().hasHostileMobs()) {
             return player;
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobSheep.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobSheep.java
index f4bb60d89..7b5a3a093 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobSheep.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobSheep.java
@@ -11,7 +11,6 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.tool.ItemToolShears;
-import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.LevelListener;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
index deabb3348..26d2b11f4 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
@@ -636,10 +636,10 @@ public class MobWolf
             if (itemstack != null && itemstack.itemID == Items.BONE.id && !isWolfAngry()) {
                 itemstack.consumeItem(player);
                 if (itemstack.stackSize <= 0) {
-                    player.inventory.setItem(player.inventory.getCurrentItemIndex(), null);
+                    player.inventory.setItem(player.inventory.getCurrentSlot(), null);
                 }
                 if (!this.world.isClientSide) {
-                    if (this.random.nextInt(3) == 0 || !player.getGamemode().consumeBlocks()) {
+                    if (this.random.nextInt(3) == 0 || !player.getGamemode().hasBlockConsumption()) {
                         setWolfTamed(true);
                         setPathToEntity(null);
                         setWolfSitting(true);
@@ -657,10 +657,10 @@ public class MobWolf
         } else {
             if (itemstack != null && (Item.itemsList[itemstack.itemID] instanceof ItemFood itemfood)) {
                 if (itemfood.getIsWolfsFavoriteMeat() && getHealth() < getMaxHealth()) {
-                    if (player.getGamemode().consumeBlocks()) {
+                    if (player.getGamemode().hasBlockConsumption()) {
                         itemstack.stackSize--;
                         if (itemstack.stackSize <= 0) {
-                            player.inventory.setItem(player.inventory.getCurrentItemIndex(), null);
+                            player.inventory.setItem(player.inventory.getCurrentSlot(), null);
                         }
                     }
                     heal(itemfood.getHealAmount());
@@ -674,10 +674,10 @@ public class MobWolf
                         setArmor(null);
                     }
                     setArmor(new ItemStack(itemstack.getItem(), 1, itemstack.getMetadata(), itemstack.getData()));
-                    if (player.getGamemode().consumeBlocks()) {
+                    if (player.getGamemode().hasBlockConsumption()) {
                         itemstack.stackSize--;
                         if (itemstack.stackSize <= 0) {
-                            player.inventory.setItem(player.inventory.getCurrentItemIndex(), null);
+                            player.inventory.setItem(player.inventory.getCurrentSlot(), null);
                         }
                     }
                     return true;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
index b39971d03..58dd6c077 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
@@ -122,7 +122,7 @@ public class MobGhast extends MobFlying
         }
         if (this.targetedEntity == null || this.aggroCooldown-- <= 0) {
             this.targetedEntity = this.world.getClosestPlayerToEntity(this, 100D);
-            if (this.targetedEntity != null && !((Player) this.targetedEntity).getGamemode().areMobsHostile()) {
+            if (this.targetedEntity != null && !((Player) this.targetedEntity).getGamemode().hasHostileMobs()) {
                 this.targetedEntity = null;
             }
             if (this.targetedEntity != null) {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
index a7f292162..36c2398a5 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
@@ -69,7 +69,7 @@ public abstract class MobMonster extends MobPathfinder
     @Override
     protected Entity findPlayerToAttack() {
         Player entityplayer = this.world.getClosestPlayerToEntity(this, 16D);
-        if (entityplayer != null && canEntityBeSeen(entityplayer) && entityplayer.getGamemode().areMobsHostile()) {
+        if (entityplayer != null && canEntityBeSeen(entityplayer) && entityplayer.getGamemode().hasHostileMobs()) {
             return entityplayer;
         } else {
             return null;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobScorpion.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobScorpion.java
index 3b7043182..aa7b4ec50 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobScorpion.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobScorpion.java
@@ -65,7 +65,7 @@ public class MobScorpion extends MobMonster
             Player p = world.getClosestPlayerToEntity(this, d);
             if (p != null)
             {
-            	if (!p.gamemode.areMobsHostile()) return null;
+            	if (!p.gamemode.hasHostileMobs()) return null;
             }
             return p;
         } else
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSlime.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSlime.java
index 85f03b35a..e4e330716 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSlime.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSlime.java
@@ -4,7 +4,6 @@ import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
-import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.World;
@@ -132,7 +131,7 @@ public class MobSlime extends Mob
     {
         tryToDespawn();
         Player entityplayer = world.getClosestPlayerToEntity(this, 16D);
-        boolean targetPlayer = entityplayer != null && entityplayer.getGamemode().areMobsHostile();
+        boolean targetPlayer = entityplayer != null && entityplayer.getGamemode().hasHostileMobs();
         if(entityplayer != null && targetPlayer)
         {
             lookAt(entityplayer, 10F, 20F);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSpider.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSpider.java
index 49dcbbb6e..151ba872a 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSpider.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSpider.java
@@ -64,7 +64,7 @@ public class MobSpider extends MobMonster
             Player p = world.getClosestPlayerToEntity(this, d);
             if (p != null)
             {
-            	if (!p.gamemode.areMobsHostile()) return null;
+            	if (!p.gamemode.hasHostileMobs()) return null;
             }
             return p;
         } else
